#pragma once

#include <atomic>

#include "Debug.hpp"
#include "Dispatcher.hpp"
#include "PrivateSemaphore.hpp"

class BinaryPrivateSemaphore : public PrivateSemaphore {
 private:
	enum State {
		initial,
		signaled,
		blocked,
	};

	std::atomic<State> bpsState;

	Context* blockedContext;

 protected:
	Context* signalInternal() override;

 public:
	BinaryPrivateSemaphore() : bpsState(initial) {}

	void wait() override;
};

typedef BinaryPrivateSemaphore BPS;
