#pragma once

#include <functional>

#include "emper-common.h"

typedef std::function<void(void)> func_t;

#define STRINGIFY(x) #x
#define TOSTRING(x) STRINGIFY(x)
#define DIE die(__FILE__ ":" TOSTRING(__LINE__), false)
#define DIE_MSG(x) die(__FILE__ ":" TOSTRING(__LINE__) " " #x, false)
#define DIE_MSG_ERRNO(x) die(__FILE__ ":" TOSTRING(__LINE__) " " #x, true)

// We compile with -fno-exceptions for the moment.
//#define THROW(x) do { throw std::runtime_error(x); } while (false)

#define likely(x) __builtin_expect(!!(x), 1)
#define unlikely(x) __builtin_expect(!!(x), 0)

#define ALIGN_TO_CACHE_LINE alignas(64)

[[noreturn]] void die(const char* message, bool usePerror);

typedef unsigned int WORD;
