#pragma once

#include "Common.hpp"
#include "Context.hpp"
#include "MemoryManager.hpp"
#include "Runtime.hpp"
#include "lib/adt/WsClQueue.hpp"

class Context;

#define CONTEXT_MANAGER_FIRST_LAYER_QUEUE_SIZE 64

class ContextManager
		: public Logger<LogSubsystem::CM>,
			protected MemoryManager<Context, 128, CONTEXT_MANAGER_FIRST_LAYER_QUEUE_SIZE> {
 private:
	const Runtime& runtime;

	friend Context;

 public:
	ContextManager(Runtime& runtime);

	Context* getFreeContext();

	void putFreeContext(Context* context);

	[[noreturn]] void start();

	void saveAndStartNew(func_t freshContextHook);

	[[noreturn]] void discardAndResume(Context* context);
};
