#pragma once

#include <atomic>

#include "PrivateSemaphore.hpp"

/**
 * A counting private semaphore.
 */
class CountingPrivateSemaphore : public PrivateSemaphore {
 private:
	std::atomic_uint counter;
	std::atomic<Context*> blockedContext;

	inline Context* signalInternal() override;

 public:
	CountingPrivateSemaphore();
	explicit CountingPrivateSemaphore(unsigned int counter);

	inline unsigned int getCounter() { return counter.load(); };

	void incrementCounterByOne();

	void incrementCounter(unsigned int count);

	virtual void wait() override;
};

typedef CountingPrivateSemaphore CPS;
