#include "Debug.hpp"

#include <iostream>
#include <mutex>

#include "Common.hpp"
#include "Runtime.hpp"

static std::mutex worker_log_mutex;

void worker_log(const std::string& prefix, const std::string& message) {
	const workerid_t workerId = Runtime::getWorkerId();

	std::unique_lock<std::mutex> lock(worker_log_mutex);
	std::cerr << (unsigned int)workerId;
	if (!prefix.empty()) {
		std::cerr << " " << prefix << " ";
	} else {
		std::cerr << "       ";
	}
	std::cerr << message << std::endl;
}
