#include "Fiber.hpp"

#include <ostream>

void Fiber::run() const {
	LOGD("run() calling " << function.target<FIBER_FUN_TEMPLATE_ARG>() << " ("
												<< function.target_type().name() << ") with arg " << arg);
	function(arg);
}

std::ostream& operator<<(std::ostream& strm, const Fiber& fiber) {
	strm << "Fiber [ptr=" << &fiber << " func=" << fiber.function.target<void(void*)>()
			 << " arg=" << fiber.arg;

	if (fiber.affinity) {
		strm << " aff=" << fiber.affinity;
	} else {
		strm << " aff=nullptr";
	}

	strm << "]";

	return strm;
}

void Fiber::print() const { std::cout << this << std::endl; }
