#include "FiberManager.hpp"

#include <cstdlib>

FiberManager::FiberManager(Runtime& runtime) : MemoryManager(runtime) {}

void* FiberManager::getFiberMemory() {
#ifdef FM_WITH_MEMORY_MANAGER
	bool malloced;
	return getMemory(&malloced);
#else
	void* mem;
	int res = posix_memalign(&mem, alignof(Fiber), sizeof(Fiber));
	if (res != 0) {
		abort();
	}
	return mem;
#endif	// FM_WITH_MEMORY_MANAGER
}

void FiberManager::putFiberMemory(Fiber* fiber) {
#ifdef FM_WITH_MEMORY_MANAGER
	putMemory(fiber);
#else
	free(fiber);
#endif	// FM_WITH_MEMORY_MANAGER
}
