#pragma once

class Runtime;
class Scheduler;
class Dispatcher;
class RuntimeStrategyStats;

#include <memory>

class RuntimeStrategy {
	friend class Runtime;

 private:
	virtual Scheduler& getScheduler(Runtime& runtime) = 0;

	virtual Dispatcher& getDispatcher(Runtime& runtime) = 0;

 public:
	virtual std::shared_ptr<RuntimeStrategyStats> getStats() = 0;
};
