#pragma once

#include <functional>

#include "Common.hpp"
#include "Debug.hpp"
#include "Fiber.hpp"

class Runtime;

class Scheduler : public Logger<LogSubsystem::SCHED> {
 protected:
	Runtime& runtime;
	Scheduler(Runtime& runtime);

	void addNewWorkerHook(std::function<void(void)> hook);

	static inline workeraffinity_t* getAffinityBuffer(Fiber& fiber) {
		return fiber.getAffinityBuffer();
	}

	static inline void increaseRefCount(Fiber& fiber) { fiber.doAtomicIncrRefCount(); }

	void notifyRuntimeAboutNewWork();

 public:
	virtual void schedule(Fiber& fiber) = 0;

	virtual Fiber* nextFiber() = 0;
};
