#pragma once

#include "emper-common.h"

typedef struct runtime runtime;

typedef struct fiber fiber;

typedef struct bps bps;

typedef struct cps cps;

#ifdef __cplusplus
extern "C" {
#endif

runtime* init_runtime(void);

void wait_until_runtime_finished();

fiber* fiber_from(void (*function)(void*), void* arg);

fiber* fiber_from0(void (*function)(void));

fiber* aff_fiber_from(void (*function)(void*), void* arg, workeraffinity_t* affinity);

fiber* aff_fiber_from0(void (*function)(void), workeraffinity_t* affinity);

void init_affinity(workeraffinity_t affinity[], unsigned int n);

void schedule(fiber* fiber);

bps* new_binary_sem(void);

void signal_bps(bps* sem);

void signal_and_exit_bps(bps* sem);

void wait_bps(bps* sem);

cps* new_counting_sem(void);

cps* new_counting_sem_with(unsigned int i);

void signal_cps(cps* sem);

void signal_and_exit_cps(cps* sem);

void wait_cps(cps* sem);

#ifdef __cplusplus
}
#endif
