#include "DebugUtil.hpp"

#include <execinfo.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

static void handler(int sig) {
	const int backtrace_size = 20;
	void* array[backtrace_size];

	size_t size = backtrace(array, backtrace_size);

	fprintf(stderr, "Error: signal %d:\n", sig);
	backtrace_symbols_fd(array, size, STDERR_FILENO);
	exit(EXIT_FAILURE);
}

void enableStacktraceOnAborts() {
	signal(SIGSEGV, handler);
	signal(SIGABRT, handler);
}
