#pragma once

namespace adt {

template <typename T, size_t N>
class BoundedBumpArray {
 private:
	static_assert(N > 1, "BoundedBumpArray size N must be greater than 1");

	size_t nextFreeElement = 0;

	T* array[N];

 public:
	bool isFull() { return nextFreeElement + 1 == N; }

	bool isEmpty() { return nextFreeElement == 0; }

	bool put(T* t) {
		if (isFull()) return false;

		array[nextFreeElement++] = t;
		return true;
	}

	T* get() {
		if (isEmpty()) return nullptr;

		return array[--nextFreeElement];
	}
};

}	 // namespace adt
