#include "LawsStrategy.hpp"

LawsStrategy LawsStrategy::INSTANCE;

Scheduler& LawsStrategy::getScheduler(Runtime& runtime) {
	Scheduler* scheduler = new LawsScheduler(runtime, *this);
	return *scheduler;
}

Dispatcher& LawsStrategy::getDispatcher(Runtime& runtime) {
	Dispatcher* dispatcher = new LawsDispatcher(runtime, *this);
	return *dispatcher;
}

std::shared_ptr<RuntimeStrategyStats> LawsStrategy::getStats() {
	return std::make_shared<LawsStrategyStats>(*this);
}
