#include "LawsStrategyStats.hpp"

#include <iostream>

#include "LawsStrategy.hpp"

LawsStrategyStats::LawsStrategyStats(LawsStrategy& lawsStrategy)
		: scheduledFibersToRemotePriority(lawsStrategy.scheduledFibersToRemotePriority),
			scheduledFibersToLocal(lawsStrategy.scheduledFibersToLocal),
			dispatchedFiberFromPriority(lawsStrategy.dispatchedFiberFromPriority),
			dispatchedFiberFromLocal(lawsStrategy.dispatchedFiberFromLocal),
			dispatchedFiberStolen(lawsStrategy.dispatchedFiberStolen),
			dispatchedFiberFromMainThread(lawsStrategy.dispatchedFiberFromMainThread) {}

uint64_t LawsStrategyStats::getScheduledFibersToRemotePriority() const {
	return scheduledFibersToRemotePriority;
}

uint64_t LawsStrategyStats::getScheduledFibersToLocal() const { return scheduledFibersToLocal; }

uint64_t LawsStrategyStats::getDispatchedFiberFromPriority() const {
	return dispatchedFiberFromPriority;
}

uint64_t LawsStrategyStats::getDispatchedFiberFromLocal() const { return dispatchedFiberFromLocal; }

uint64_t LawsStrategyStats::getDispatchedFiberStolen() const { return dispatchedFiberStolen; }

uint64_t LawsStrategyStats::getDispatchedFiberFromMainThread() const {
	return dispatchedFiberFromMainThread;
}

void LawsStrategyStats::print() {
	std::cout << "LawsStrategyStats"
						<< " scheduledFibersToRemotePriority:" << scheduledFibersToRemotePriority
						<< " scheduledFibersToLocal:" << scheduledFibersToLocal
						<< " dispatchedFiberFromPriority:" << dispatchedFiberFromPriority
						<< " dispatchedFiberFromLocal:" << dispatchedFiberFromLocal
						<< " dispatchedFiberStolen:" << dispatchedFiberStolen
						<< " dispatchedFiberFromMainThread:" << dispatchedFiberFromMainThread << std::endl;
}
