#pragma once

#include <cstdint>

#include "RuntimeStrategyStats.hpp"

class LawsStrategy;

class LawsStrategyStats : public RuntimeStrategyStats {
 private:
	const uint64_t scheduledFibersToRemotePriority;
	const uint64_t scheduledFibersToLocal;
	const uint64_t dispatchedFiberFromPriority;
	const uint64_t dispatchedFiberFromLocal;
	const uint64_t dispatchedFiberStolen;
	const uint64_t dispatchedFiberFromMainThread;

 public:
	LawsStrategyStats(LawsStrategy& lawsStrategy);

	uint64_t getScheduledFibersToRemotePriority() const;
	uint64_t getScheduledFibersToLocal() const;
	uint64_t getDispatchedFiberFromPriority() const;
	uint64_t getDispatchedFiberFromLocal() const;
	uint64_t getDispatchedFiberStolen() const;
	uint64_t getDispatchedFiberFromMainThread() const;

	virtual void print();
};
