#include "WsDispatcher.hpp"

#include "Debug.hpp"
#include "Runtime.hpp"
#include "emper-config.h"

void WsDispatcher::dispatchLoop() {
	while (true) {
		const Fiber* fiber = runtime.nextFiber();
		if (!fiber) {
#ifdef EMPER_WORKER_SLEEP
			putRuntimeWorkerToSleep();
#else
			pthread_yield();
#endif
			continue;
		}

		dispatch(fiber);

		recycle(fiber);
	}
}
