#pragma once

#include "Scheduler.hpp"
#include "emper-common.h"
#include "emper-config.h"
#include "lib/adt/LockedQueue.hpp"
#include "lib/adt/WsClQueue.hpp"

class WsStrategy;

class WsScheduler : public Scheduler {
	template <size_t SIZE>
#ifdef EMPER_LOCKED_WS_QUEUE
	using WsQueue = adt::LockedQueue<Fiber*, SIZE>;
#else
	using WsQueue = adt::WsClQueue<Fiber*, SIZE>;
#endif

 public:
	static const int QUEUE_SIZE = 1024;

 private:
	WsQueue<QUEUE_SIZE>** queues;
	static thread_local WsQueue<QUEUE_SIZE> queue;

	WsQueue<QUEUE_SIZE>* mainThreadQueue;

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wattributes"
	WsStrategy& wsStrategy
#ifndef EMPER_STATS
			ATTR_UNUSED
#endif
			;
#pragma GCC diagnostic pop

 public:
	WsScheduler(Runtime& runtime, WsStrategy& wsStrategy);

	void schedule(Fiber& fiber) override;

	Fiber* nextFiber() override;
};
