#include "WsStrategy.hpp"

#include "WsDispatcher.hpp"
#include "WsScheduler.hpp"

WsStrategy WsStrategy::INSTANCE;

Scheduler& WsStrategy::getScheduler(Runtime& runtime) {
	Scheduler* scheduler = new WsScheduler(runtime, *this);
	return *scheduler;
}

Dispatcher& WsStrategy::getDispatcher(Runtime& runtime) {
	Dispatcher* dispatcher = new WsDispatcher(runtime);
	return *dispatcher;
}

std::shared_ptr<RuntimeStrategyStats> WsStrategy::getStats() {
	return std::make_shared<WsStrategyStats>(*this);
}
