#pragma once

#include <atomic>
#include <cstdint>
#include <memory>

#include "RuntimeStrategy.hpp"
#include "WsStrategyStats.hpp"

class Scheduler;
class Dispatcher;

class WsScheduler;
class WsDispatcher;

class WsStrategy : public RuntimeStrategy {
 private:
	std::atomic<std::uint64_t> scheduledFibers;
	std::atomic<std::uint64_t> nextFiberFromLocal;
	std::atomic<std::uint64_t> nextFiberStolen;

	WsStrategy() : scheduledFibers(0), nextFiberFromLocal(0), nextFiberStolen(0) {}

	Scheduler& getScheduler(Runtime& runtime);

	Dispatcher& getDispatcher(Runtime& runtime);

 public:
	virtual std::shared_ptr<RuntimeStrategyStats> getStats();

	static WsStrategy INSTANCE;

	friend WsScheduler;
	friend WsDispatcher;
	friend WsStrategyStats;
};
