#include "WsStrategyStats.hpp"

#include <iostream>

#include "WsStrategy.hpp"

WsStrategyStats::WsStrategyStats(WsStrategy& wsStrategy)
		: scheduledFibers(wsStrategy.scheduledFibers),
			nextFiberFromLocal(wsStrategy.nextFiberFromLocal),
			nextFiberStolen(wsStrategy.nextFiberStolen) {}

uint64_t WsStrategyStats::getScheduledFibers() const { return scheduledFibers; }

uint64_t WsStrategyStats::getNextFiberFromLocal() const { return nextFiberFromLocal; }

uint64_t WsStrategyStats::getNextFiberStolen() const { return nextFiberStolen; }

void WsStrategyStats::print() {
	std::cout << "WsStrategyStats"
						<< " scheduledFibers:" << scheduledFibers
						<< " nextFiberFromLocal:" << nextFiberFromLocal
						<< " nextFiberStolen:" << nextFiberStolen << std::endl;
}
