#pragma once

#include <cstdint>

#include "RuntimeStrategyStats.hpp"

class WsStrategy;

class WsStrategyStats : public RuntimeStrategyStats {
 private:
	const uint64_t scheduledFibers;
	const uint64_t nextFiberFromLocal;
	const uint64_t nextFiberStolen;

 public:
	WsStrategyStats(WsStrategy& wsStrategy);

	uint64_t getScheduledFibers() const;
	uint64_t getNextFiberFromLocal() const;
	uint64_t getNextFiberStolen() const;

	virtual void print();
};
